<template>
    <div>
        <table>
            <thead>
                <tr>
                    <th>일련번호</th>
                    <th>아이디</th>
                    <th>제목</th>
                    <th>내용</th>
                    <th>등록일시</th>
                </tr>
            </thead>
            <colgroup>
                <col width="20%">
                <col width="20%">
                <col width="20%">
                <col width="20%">
                <col width="20%">
            </colgroup>
            <tbody>
                <tr v-for="(sample) in page.content" :key="sample.id">
                    <td><router-link :to="`/samples/view/${sample.id}`">{{sample.id}}</router-link></td>
                    <td>{{sample.userId}}</td>
                    <td>{{sample.title}}</td>
                    <td>{{sample.content}}</td>
                    <td>{{sample.createdAt}}</td>
                </tr>
            </tbody>
        </table>
        <router-link to="/samples/add">
            <button>등록</button>
        </router-link>
    </div>
</template>

<script lang="ts">
    import {Vue}         from 'vue-property-decorator';
    import {Watch}       from 'vue-property-decorator';
    import {Component}   from 'vue-property-decorator';
    import {Common}      from '@/io/niceday/common/engine/model/Common';
    import {Sample}      from '@/io/niceday/sample/model/Sample'; 
    import {SampleStore} from '@/io/niceday/sample/store/SampleStore'; 

    @Component
    export default class SampleList extends Vue {

        private store  = SampleStore.getInstance();
        private search = new Sample.Request.Search;
        private page   = new Common.Response.Page;
        
        private created() {
            this.store.actions.getPage(this.search);
        }

        @Watch('store.state.page')
        private setPage() : void {
            this.page = this.store.getters.getPage();
        }
    }
</script>